# Copyright 2018 Cumulus Networks, Inc.  All Rights reserved.
# This software is subject to the Cumulus Networks End User License Agreement
# available at the following locations:
# Internet: https://cumulusnetworks.com/downloads/eula/latest/view/
# Cumulus Linux systems: /usr/share/cumulus/EULA.txt

from __future__ import absolute_import
import psutil
from netq_lib.orm.redisdb.models import ResourceUtil
from netq_lib.common.enums import ServiceStatus

def process_resource_util(cmd_output, svc_failed=False, **kwargs):

    cpu_util = psutil.cpu_percent()
    mem_percent_util = psutil.virtual_memory().percent
    new_resource_util_obj = ResourceUtil()
    new_resource_util_obj.cpu_utilization = cpu_util
    new_resource_util_obj.mem_utilization = mem_percent_util

    new_resource_util_obj.save()

    return ServiceStatus.OK